﻿using System;
using Microsoft.SPOT;
using System.Net;
using System.IO;
using DeviceSolutions.SPOT.Hardware;

namespace DemoWebServer
{
    public class Program
    {
        public static void Main()
        {
            // Creo un server in ascolto di richieste http
            HttpListener server = new HttpListener("http",8080);

            // lo avvio...
            server.Start();

            while (true)
            {
                HttpListenerResponse response = null;
                HttpListenerContext context = null;

                try
                {
                    // Aspetto una richiesta http (questa chiamata è bloccante)
                    context = server.GetContext();
                    response = context.Response;

                    HttpListenerRequest request = context.Request;

                    // Verifico che la richiesta fatta sia del tipo "http://<indirizzo>:8080/status"
                    if (request.RawUrl == "/status")
                    {
                        // Mando lo status code 200 (OK)
                        response.StatusCode = (int)HttpStatusCode.OK;

                        // Comunico al browser che il contenuto va visualizzato come html
                        response.ContentType = "text/html";

                        // Compongo la risposta...
                        using(StreamWriter sw=new StreamWriter(response.OutputStream))
                        {
                            string html = "<html><head><title>.NET MF Test Page</title></head><body><h1>Questo &#232; un server web realizzato con .NET Micro Framework</h1>";
                            html += "<h2>";
                            html += "Qui la temperatura &#232; di " + TahoeII.Tsc2046.ReadTemperature().ToString("F") + "&#186;C";
                            html += "</h2>";
                            html += "</body></html>";

                            sw.Write(html);
                        }
                    }
                }
                catch
                {
                    // Se ci sono stati problemi nella richiesta chiudo comunque il contesto...
                    if (context != null) context.Close();
                }
            }
        }

    }
}
