﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Net;

namespace TCPSocketServer
{
    class Program
    {
        static void Main(string[] args)
        {
            TcpListener listener = new TcpListener(new IPEndPoint(IPAddress.Any, 1234));

            listener.Start();

            Console.WriteLine("Server started...");

            while (true)
            {
                TcpClient client = listener.AcceptTcpClient();

                Console.WriteLine(string.Format("{0} Connected!", client.Client.RemoteEndPoint));

                using (StreamReader sr = new StreamReader(client.GetStream()))
                {
                    string s = sr.ReadLine();

                    Console.WriteLine(string.Format("Received: {0}", s));

                    using (StreamWriter sw = new StreamWriter(client.GetStream()))
                    {
                        switch (s.ToLower())
                        {
                            case "exit":
                                listener.Stop();
                                break;

                            case "?":
                                sw.WriteLine("TCPSocketServer 1.0");
                                break;
                        }
                    }
                }
            }
        }
    }
}
