﻿using System;
using Microsoft.SPOT;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.Threading;

namespace TestTCPClient
{
    public static class Program
    {
        public static void Main()
        {
            // Apertura connessione TCP al server "pip" su porta IP 1234
            using (Socket socket = Connect("cartman.main.innovactive.it", 1234))
            {
                byte[] tx = Encoding.UTF8.GetBytes("?\r\n");

                // Invio al socket la stringa "?+<invio>"
                socket.Send(tx);

                // Attendo fino a che non arriva risposta...
                while (socket.Available == 0)
                {
                    Thread.Sleep(100);
                }

                string rxstring = string.Empty;

                // fino a che il socket è leggibile...
                while(socket.Poll(-1,SelectMode.SelectRead))
                {
                    byte[] rx=new byte[1024];

                    // viene popolato il buffer...
                    socket.Receive(rx);

                    // concateniamo alla stringa ricevuta fino a qui...
                    rxstring += new string(Encoding.UTF8.GetChars(rx));

                    // se non ci sono dati disponibili in ingresso esco dal ciclo
                    if (socket.Available == 0) break;
                }

                // La stringa ricevuta finora è...
                Debug.Print(rxstring);
            }
        }

        static Socket Connect(string server, int port)
        {
            // Risolvo il nome DNS del server
            IPHostEntry host = Dns.GetHostEntry(server);

            // Creo un socket TCP
            Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            // connetto il socket ad uno degli indirizzi del server (il primo), alla porta IP richiesta
            sock.Connect(new IPEndPoint(host.AddressList[0],port));

            // una volta connesso, restituisco il socket aperto al chiamante...
            return sock;
        }

    }
}
